--[[
	Bagnon
		Displays the player's inventory in a single frame
--]]

--[[ 
	Loading Functions
--]]

function Bagnon_OnLoad()
	this:RegisterEvent("ADDON_LOADED");
end

--[[
	Event Handler
--]]

function Bagnon_OnEvent(event)
	if ( event == "BANKFRAME_OPENED") then
		BagnonCore_Open("Bagnon");
	elseif ( event == "ADDON_LOADED" and arg1 == "Bagnon") then
		this:UnregisterEvent("ADDON_LOADED");
		Bagnon_Load();
	end
end

function Bagnon_Load()
	BagnonCore_LoadSettings(Bagnon, {0, 1, 2, 3, 4}, 164, "Inventory");
	this:RegisterEvent("BANKFRAME_OPENED");
	
	Bagnon_AddBagHooks();
end

--[[
	UI Functions
--]]

--OnShow
function Bagnon_OnShow()
	MainMenuBarBackpackButton:SetChecked(1);
	PlaySound("igBackPackOpen");
end

--OnHide
function Bagnon_OnHide()
	MainMenuBarBackpackButton:SetChecked(0);
	PlaySound("igBackPackClose");
end

--Show Bags

function Bagnon_ToggleBags()
	if( not BagnonBags:IsShown() ) then
		BagnonBags:Show();
		this:SetText(BAGNON_HIDEBAGS);
	else
		BagnonBags:Hide();
		this:SetText(BAGNON_SHOWBAGS);
	end
	
	BagnonCore_TrimToSize(Bagnon);
end

--[[
	Bag Overrides
--]]

function Bagnon_AddBagHooks()
	Old_BagSlotButton_OnEnter = BagSlotButton_OnEnter;
	BagSlotButton_OnEnter = BagnonBlizBag_OnEnter;
	
	Old_MainBag_OnEnter = MainMenuBarBackpackButton:GetScript("OnEnter");
	MainMenuBarBackpackButton:SetScript("OnEnter", BagnonMainBag_OnEnter);
	MainMenuBarBackpackButton:SetScript("OnLeave", BagnonBlizBag_OnLeave);
	
	local i;
	for i = 0, 3 do
		getglobal("CharacterBag" .. i .. "Slot"):SetScript("OnLeave", BagnonBlizBag_OnLeave);
	end
end


function BagnonBlizBag_OnEnter()
	if(Bagnon:IsShown() ) then
		BagnonCore_HighlightSlots(Bagnon, this:GetID() - 19);
	end
	
	Old_BagSlotButton_OnEnter();
end;

function BagnonMainBag_OnEnter()
	if(Bagnon:IsShown() ) then
		BagnonCore_HighlightSlots(Bagnon, this:GetID());
	end
	Old_MainBag_OnEnter();
end

function BagnonBlizBag_OnLeave()
	GameTooltip:Hide();
	BagnonCore_UnhighlightAll(Bagnon);
end