--[[
	Menu.lua
		Functions for the Bagnon right click options menu
--]]

local FRAMESTRATA = {"LOW", "MEDIUM", "HIGH"};


--show the menu
function BagnonMenu_Show(frame)
	BagnonMenu.frame = frame;
	--BagnonMenu:SetParent(frame);
	
	BagnonMenu.onShow = 1;
	BagnonMenuText:SetText(frame:GetName() .. " Settings");
	
	--Set values
	BagnonMenuLocked:SetChecked(BagnonSets[frame:GetName()].locked);
	BagnonMenuOpaque:SetChecked(BagnonSets[frame:GetName()].bg);
	BagnonMenuReverse:SetChecked(BagnonSets[frame:GetName()].reverse);
	BagnonMenuColumns:SetValue(frame.cols);
	BagnonMenuSpacing:SetValue(frame.space);
	BagnonMenuScale:SetValue(frame:GetScale() * 100);
	BagnonMenuOpacity:SetValue(frame:GetAlpha() * 100);
	
	if(BagnonSets[frame:GetName()].strata) then
		BagnonMenuStrata:SetValue(BagnonSets[frame:GetName()].strata);
	else
		BagnonMenuStrata:SetValue(2);
	end
	
	--a nifty thing I saw in meta map adapted for my usage
	--places the options menu at the cursor's position
	local x, y = GetCursorPosition();
	x = x / UIParent:GetScale();
	y = y / UIParent:GetScale();
	
	BagnonMenu:ClearAllPoints();
	Infield_Place(BagnonMenu, "TOPLEFT", UIParent, "BOTTOMLEFT", x, y);
	
	BagnonMenu:Show();
	BagnonMenu.onShow = nil;
end

--change <frame>'s transparency
function BagnonMenu_SetAlpha(frame, alpha)
	if(alpha ~= 1) then
		BagnonSets[frame:GetName()].alpha = alpha;
	else
		BagnonSets[frame:GetName()].alpha = nil
	end
	frame:SetAlpha(alpha);
end

--Set and scale <frame>
function BagnonMenu_SetScale(frame, scale)
	BagnonSets[frame:GetName()].scale = scale;
	
	Infield_Scale(frame, scale);
	BagnonCore_SavePosition(frame);
end

--set the layer of the frame
function BagnonMenu_SetStrata(frame, strata)
	BagnonSets[frame:GetName()].strata = strata;
	frame:SetFrameStrata(FRAMESTRATA[strata]);
end

--set the background of the frame between opaque/transparent
function BagnonMenu_ToggleBG(frame, checked)
	if( checked ) then
		BagnonMenu_SetBackground(frame, bgn_OPAQUE_BG);
	else
		BagnonMenu_SetBackground(frame, bgn_NORMAL_BG);
	end
end

--set the inventory slots to be organized in either a reversed or normal order
function BagnonMenu_ToggleOrder(frame, checked)
	if( checked ) then
		BagnonSets[frame:GetName()].reverse = 1;
	else
		BagnonSets[frame:GetName()].reverse = nil;
	end
	BagnonCore_OrderBags(frame, checked);
	BagnonCore_GenerateFrame(frame);
end

--switch set the frame's background, currently only switches to/from a transparent background
function BagnonMenu_SetBackground(frame, background)
	if(background == bgn_NORMAL_BG) then
		BagnonSets[frame:GetName()].bg = nil;
	else
		BagnonSets[frame:GetName()].bg = 1;
	end
	
	frame:SetBackdrop({bgFile=background, edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile=false, tileSize=16, edgeSize=16, insets={left=4, right=4, top=4, bottom=4}});
end

function BagnonMenu_ToggleLock(frame, checked)
	local frameName = frame:GetName();
	
	if(checked) then
		BagnonSets[frameName].locked = 1;
	else
		BagnonSets[frameName].locked = nil;
	end
end