-- Table to hold all the anchor positions used in BeneCast
BeneCast_SnapTo = {};

-- Standard UI anchor positions
BeneCast_SnapTo.STANDARD = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "PlayerFrame", relativePoint = "BOTTOM", x = -10, y = 30 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "PartyMemberFrame1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "PartyMemberFrame2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "PartyMemberFrame3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "PartyMemberFrame4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "PartyMemberFrame1PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "PartyMemberFrame2PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "PartyMemberFrame3PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "PartyMemberFrame4PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "LEFT", frame = "TargetFrame", relativePoint = "RIGHT", x = -20, y = 7 },
	
	AddOn = 'BeneCast',
		
};

-- Perl anchor positions
BeneCast_SnapTo.PERLNYMBIA  = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "Perl_Player_Frame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "Perl_party1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "Perl_party2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "Perl_party3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "Perl_party4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "Perl_Party_Pet1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "Perl_Party_Pet2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "Perl_Party_Pet3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "Perl_Party_Pet4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "Perl_Target_Frame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'Perl',
		
};

-- Perl anchor positions
BeneCast_SnapTo.PERLCLASSIC = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "Perl_Player_Frame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "Perl_Party_MemberFrame1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "Perl_Party_MemberFrame2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "Perl_Party_MemberFrame3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "Perl_Party_MemberFrame4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "Perl_Party_MemberFrame1_StatsFrame_PetHealthBar", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "Perl_Party_MemberFrame2_StatsFrame_PetHealthBar", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "Perl_Party_MemberFrame3_StatsFrame_PetHealthBar", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "Perl_Party_MemberFrame4_StatsFrame_PetHealthBar", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "Perl_Target_Frame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'Perl_Target',
		
};

-- Minigroup anchor positions
BeneCast_SnapTo.MINIGROUP = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "MGParty_Member0", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "MGParty_Member1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "MGParty_Member2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "MGParty_Member3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "MGParty_Member4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "MGTarget_Frame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'MiniGroup',
		
};

-- Minigroup anchor positions
BeneCast_SnapTo.MINIGROUP2 = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "MGplayer", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "MGparty1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "MGparty2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "MGparty3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "MGparty4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "MGpartypet1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "MGpartypet2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "MGpartypet3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "MGpartypet4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "MGtarget", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'MiniGroup2',
		
};

-- Nurfed anchor positions
BeneCast_SnapTo.NURFED = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "Nurfed_player", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "Nurfed_party1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "Nurfed_party2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "Nurfed_party3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "Nurfed_party4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "Nurfed_partypet1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "Nurfed_partypet2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "Nurfed_partypet3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "Nurfed_partypet4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "Nurfed_target", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'Nurfed_UnitFrames',
		
};

-- Noctambul anchor positions
BeneCast_SnapTo.NOCTAMBUL = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "NUFPlayerFrame", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame1", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame2", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame3", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame4", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame1PetFrame", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame2PetFrame", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame3PetFrame", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame4PetFrame", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "NUFTargetFrame", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	
	AddOn = 'NUF',
		
};

-- SAE_PartyFrame 
BeneCast_SnapTo.SAE_PARTYFRAME = { 

	-- Player Frame 
	BeneCastPanel1 = { point = "TOPLEFT", frame = "PlayerFrame", relativePoint = "BOTTOM", x = -10, y = 30 }, 

	-- Party Frames 
	BeneCastPanel2 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame1", relativePoint = "TOPRIGHT", x = -5, y = -5 }, 
	BeneCastPanel3 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame2", relativePoint = "TOPRIGHT", x = -5, y = -5 }, 
	BeneCastPanel4 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame3", relativePoint = "TOPRIGHT", x = -5, y = -5 }, 
	BeneCastPanel5 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame4", relativePoint = "TOPRIGHT", x = -5, y = -5 }, 

	-- Player Pet Frame 
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 }, 

	-- Party Pet Frames 
	BeneCastPanel47 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame1PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 2 }, 
	BeneCastPanel48 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame2PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 2 }, 
	BeneCastPanel49 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame3PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 2 }, 
	BeneCastPanel50 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame4PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 2 }, 

	-- Target Frame 
	BeneCastPanel91 = { point = "LEFT", frame = "TargetFrame", relativePoint = "RIGHT", x = -20, y = 7 }, 

	AddOn = 'SAE_PartyFrame', 
}; 



-- Watchdog anchor positions
BeneCast_SnapTo.WATCHDOG = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "WatchDogFrame_player", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "WatchDogFrame_party1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "WatchDogFrame_party2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "WatchDogFrame_party3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "WatchDogFrame_party4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "WatchDogFrame_partypet1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "WatchDogFrame_partypet2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "WatchDogFrame_partypet3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "WatchDogFrame_partypet4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "WatchDogFrame_target", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'WatchDog',
		
};

-- Discord anchor positions
BeneCast_SnapTo.DISCORD = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "DUF_PlayerFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "DUF_PartyFrame1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "DUF_PartyFrame2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "DUF_PartyFrame3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "DUF_PartyFrame4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "DUF_PartyPetFrame1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "DUF_PartyPetFrame2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "DUF_PartyPetFrame3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "DUF_PartyPetFrame4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "DUF_TargetFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'DiscordUnitFrames',
		
};

-- Table for raid AddOn options in BeneCast
BeneCast_RaidSnapTo = {};

-- Standard UI Raid Anchors
BeneCast_RaidSnapTo.STANDARD = {

	AddOn = 'BeneCast',

}

-- CT_Raid Anchors
BeneCast_RaidSnapTo.CT_RAID = {

	AddOn = 'CT_RaidAssist',

}