--[[

	Insomniax PlayerFramePlus v1900.2
	by LedMirage and Ascendant, http://www.insomniax.net
	1.19.2006

]]

-- Ascendant 08.20.05 - global variables to handle special toggles
local bVarsLoaded = false;
local bModLoaded = false;
local bPlayerEntered = false;	-- toggle to determine if the PLAYER_ENTERING_WORLD executed already, should prevent the xp bar from disappearing if set to show by lvl 60 chars when entering/leaving instances
local nLevelCap = 60;			-- constant to determine level at which the xp bar will always be hidden on load
-- end of Asc's addition

function IX_PlayerFrameOnLoad ()
	-- Experience registrations
	this:RegisterEvent("PLAYER_XP_UPDATE");
	this:RegisterEvent("UPDATE_EXHAUSTION");
	this:RegisterEvent("PLAYER_LEVEL_UP");
	-- Register for variable loading to run our configuration registrations
	this:RegisterEvent("VARIABLES_LOADED");			-- Ascendant 08.20.05
	this:RegisterEvent("PLAYER_ENTERING_WORLD");	-- Ascendant 08.20.05
	this:RegisterEvent("PLAYER_LOGIN"); 			-- Ascendant 01.17.06	

	-- Ascendant 08.20.05 - added slash command definition
	SLASH_IX1 = "/ix";

	SlashCmdList["IX"] = function(msg)
		Asc_IXSlashCmdHndlr(msg);
	end
	-- end of Asc's addition
	
end

function IX_PlayerFrameOnEvent (event)
	
	-- Ascendant 08.20.05 - added VARIABLES_LOADED event handler
	if (event == "VARIABLES_LOADED") then
		bVarsLoaded = true;
		if (not bModLoaded) then
			local playerName = UnitName("player");		
			if (playerName ~= nil) or (playerName ~= "unknown") or (playerName ~= UNKNOWNBEING) or (playerName ~= UNKNOWNOBJECT) then
				if (bModLoaded) then 
					return; 
				end
				if (not bVarsLoaded) then 
					return; 
				end
				if (IXPlayerFrame == nil) then
					IXPlayerFrame = true;			
				end
				bModLoaded = true;
			end
		end
		return;
	end
	-- end of Asc's addition
	
	if ( event == "PLAYER_ENTERING_WORLD" ) then
		-- We need to do an initial display of	all our values when the player first logs in.
		IX_ShowPlayerExp();
	end

	if ( event == "PLAYER_ENTERED_WORLD" ) then	
		-- Ascendant 08.20.05 - shows/hides player frame xp bar - always hides for characters at level 60 on load
		if (IXPlayerFrame ~= nil) then
			if (UnitLevel("player") >= nLevelCap) and (not bPlayerEntered) then
				IXPlayerFrame = false;
				Asc_IXHideXP();
			else
				if (IXPlayerFrame) then
					Asc_IXShowXP();
				else
					Asc_IXHideXP();
				end
			end
			bPlayerEntered = true;
		end
		-- end of Asc's addition
	end
	-- Added unit exp handles to update the player displayed experience numbers.
	if(event == "PLAYER_XP_UPDATE" or event == "UPDATE_EXHAUSTION" or event == "PLAYER_LEVEL_UP") then
		IX_ShowPlayerExp();
		return;
	end
	
end


function IX_ShowPlayerExp()
	local currXP = UnitXP("player");
	local nextXP = UnitXPMax("player");
	local restXP = GetXPExhaustion();

	if(restXP == nil) then
		local str = format("%s / %s", currXP, nextXP);
		IX_ExpAmount:SetText(str);
	else
		-- Divide the rested # in half because
		-- (a) that's the exp you really end up getting
		-- (b) it isn't such an absurdly huge number taking up a lot of space on the UI.

		local str = format("%s / %sxp  (+%sxp)", currXP, nextXP, (tonumber(restXP) / 2));
		IX_ExpAmount:SetText(str);
	end
end

-- ** EXPERIENCE BAR FUNCTIONS ** --

function IX_PlayerFrameExpBarOnLoad ()
	-- Experience bar registrations
	this:RegisterEvent("PLAYER_XP_UPDATE");
	this:RegisterEvent("PLAYER_LEVEL_UP");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	-- Can not be any higher, should not be lower
	this:SetFrameLevel("1");	
end

function IX_PlayerFrameExpBarOnEvent (event)
	-- Setup our experience bar when the player logs in, when experience changes, or when the player levels up
	if (event == "PLAYER_XP_UPDATE" or event == "PLAYER_LEVEL_UP" or event == "PLAYER_ENTERING_WORLD") then
		local currXP = UnitXP("player");
		local nextXP = UnitXPMax("player");
		this:SetMinMaxValues(min(0, currXP), nextXP);
		this:SetValue(currXP);
		return;
	end
end



-- ** PET BAR RELOCATION FUNCTION ** --


function IX_UpdatePetFrame()

	if(PetFrame:IsVisible()) then

		local petAnchor = {point = "TOPLEFT", rel = "PlayerFrame", relPoint="TOPLEFT", x = "80", y = "-75"};

		PetFrame:ClearAllPoints();
		PetFrame:SetPoint(petAnchor.point, petAnchor.rel, petAnchor.relPoint, petAnchor.x, petAnchor.y);
	end
end

--[[ LedMirage 12/09/2005:  Removed IX_UpdatePetFrame() and replaced it with 2 new functions:
	IX_UpdatePetFrameIfXPHidden();
	IX_UpdatePetFrameIfXPShown();
	Works like a charm updating position of pet frame with SLASH command /ix hidexp /ix showxp
]]

function IX_UpdatePetFrameIfXPHidden()

	if(PetFrame:IsVisible()) then

		local petAnchor = {point = "TOPLEFT", rel = "PlayerFrame", relPoint="TOPLEFT", x = "80", y = "-55"};

		PetFrame:Hide();
		PetFrame:ClearAllPoints();
		PetFrame:SetPoint(petAnchor.point, petAnchor.rel, petAnchor.relPoint, petAnchor.x, petAnchor.y);
		PetFrame:Show();
	end
end

function IX_UpdatePetFrameIfXPShown()

	if(PetFrame:IsVisible()) then

		local petAnchor = {point = "TOPLEFT", rel = "PlayerFrame", relPoint="TOPLEFT", x = "80", y = "-75"};
		
		PetFrame:Hide();
		PetFrame:ClearAllPoints();
		PetFrame:SetPoint(petAnchor.point, petAnchor.rel, petAnchor.relPoint, petAnchor.x, petAnchor.y);
		PetFrame:Show();
	end
end

-- ** ASCENDANT'S FUNCTIONS ** --

function Asc_IXHideXP()
	-- hide xp bar on playerframe

	IX_PlayerFrameExpBar:Hide();
	IX_ExpAmount:Hide();
	IX_PlayerFramePlus:SetTexture("Interface\\AddOns\\Insomniax_PlayerFramePlus\\Insomniax_PlayerFramePlus60.tga");
	IX_UpdatePetFrameIfXPHidden();

end

function Asc_IXShowXP()
	-- show xp bar on playerframe

	IX_PlayerFrameExpBar:Show();
	IX_ExpAmount:Show();
	IX_PlayerFramePlus:SetTexture("Interface\\AddOns\\Insomniax_PlayerFramePlus\\Insomniax_PlayerFramePlus.tga");
	IX_UpdatePetFrameIfXPShown();

end

function Asc_IXXP_Help()

	DEFAULT_CHAT_FRAME:AddMessage("Insomniax PlayerFramePlus toggle usage:",225/255, 0, 175/255);
	DEFAULT_CHAT_FRAME:AddMessage("This tweak will always hide the Insomniax PlayerFrame XP Bar on load for characters at level 60 regardless of last saved setting.")
	DEFAULT_CHAT_FRAME:AddMessage("You may show the xp bar at any time after the game has loaded.");
	DEFAULT_CHAT_FRAME:AddMessage("\"/ix hidexp\" will hide the XP bar attached to the Insomniax Player Frame.");
	DEFAULT_CHAT_FRAME:AddMessage("\"/ix showxp\" will show the XP bar attached to the Insomniax Player Frame.");

end

function Asc_IXSlashCmdHndlr(msg)
	-- slash command handler implementation
	
	msg = string.lower(msg);

	if (strfind (msg, "hidexp")) then
		if (not IXPlayerFrame) then
			DEFAULT_CHAT_FRAME:AddMessage("The Insomniax PlayerFramePlus XP bar is already hidden.");
		else
			Asc_IXHideXP();
			IXPlayerFrame = false;
			DEFAULT_CHAT_FRAME:AddMessage("The Insomniax PlayerFramePlus XP bar is now hidden.");
		end
	elseif (strfind (msg, "showxp")) then
		if (IXPlayerFrame) then
			DEFAULT_CHAT_FRAME:AddMessage("The Insomniax PlayerFramePlus XP bar is already being displayed.");
		else
			Asc_IXShowXP();
			IXPlayerFrame = true;
			DEFAULT_CHAT_FRAME:AddMessage("The Insomniax PlayerFramePlus XP bar is now being displayed.");
		end
	else
		Asc_IXXP_Help();
	end

end
