--[[--------------------------------------------------------------------------------
  ItemSyncCore Optimize Framework

  Author:  Derkyle
  Website: http://www.manaflux.com
-----------------------------------------------------------------------------------]]

local ISync_OptCount = 0;
local ISync_OptCount_Current = 0;

---------------------------------------------------
-- ISync:Optimize_Load
---------------------------------------------------
function ISync:Optimize_Load()

	--initiate the timer variables
  	ISync_Optimize_Timer.Todo = {};
  	ISync_Optimize_Timer.Todo.n = 0;
  
end


---------------------------------------------------
-- ISync:Optimize_Update()
---------------------------------------------------
function ISync:Optimize_Update()

	while(ISync_Optimize_Timer.Todo[1] and 
	
		ISync_Optimize_Timer.Todo[1].time <= GetTime()) do
		
		--load the todo variable
		local todo = table.remove(ISync_Optimize_Timer.Todo,1);
		
		--check if there are arguments if so then load them
		if(todo.args) then
			todo.handler(unpack(todo.args));
		--otherwise run the function
		else
			todo.handler();
		end--if(todo.args) then
		
	end--end while
	
end


---------------------------------------------------
-- ISync:Optimize_Add()
---------------------------------------------------
function ISync:Optimize_Add(when,handler,...)

	--load the todo variable
	local todo = {};
	local i = 1;

	--set the time so that we can determine time passed later
	todo.time = when + GetTime();
	--save the handler for processing later
	todo.handler = handler;
	--save the arguements if there are any
	todo.args = arg;
	
	--start the while loop
	while(ISync_Optimize_Timer.Todo[i] and
	
		--syncronize the time
		ISync_Optimize_Timer.Todo[i].time < todo.time) do
		i = i + 1;
	end
	
	--insert the finished product into the frame's todo array
	table.insert(ISync_Optimize_Timer.Todo,i,todo);

end


--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------



---------------------------------------------------
-- ISync:Optimize
---------------------------------------------------
function ISync:Optimize(sNum)
local upNum = 0;
local upNum2 = 0;
local stopChk = 0;
local sParseLink;

	if(sNum == 0) then
		ISync_Optimize_Timer.Todo = {};
  		ISync_Optimize_Timer.Todo.n = 0;
  		ISync_OptCount = 0;
  		ISync_OptCount_Current = 0;
  	end


	--check on database
	if(not ISyncDB) then return nil; end
	if(not ISync_RealmNum) then return nil; end
	if(not ISyncDB[ISync_RealmNum]) then return nil; end
	if(not sNum and ISync_OptCount_Current) then sNum = ISync_OptCount_Current; end
	if(not sNum and ISync_OptCount_Current == 0) then return nil; end
	
	--disable the button
	ISync_OptionsOptimizeButton:Disable();
	
	--get the itemcount only if it hasn't been done already
	if(ISync_OptCount == 0) then
	
		for index, value in ISyncDB[ISync_RealmNum] do
			ISync_OptCount = ISync_OptCount + 1;
		end
	
		--check for errors
		if(not ISync_OptCount) then

			if( DEFAULT_CHAT_FRAME ) then
				DEFAULT_CHAT_FRAME:AddMessage("|c0000FF00ItemSync: There were no items to process.");
			end
			
			--Enable the button
			ISync_OptionsOptimizeButton:Enable();

			return nil;

		elseif(ISync_OptCount == 0) then

			if( DEFAULT_CHAT_FRAME ) then
				DEFAULT_CHAT_FRAME:AddMessage("|c0000FF00ItemSync: There were no items to process.");
			end

			--Enable the button
			ISync_OptionsOptimizeButton:Enable();
			
			return nil;

		else
			--set the status bar
			ISync_Optimize_Bar:SetAlpha(1);
			ISync_Optimize_BarFrameStatusBar:SetStatusBarColor(1, 1, 0);
			ISync_Optimize_BarFrameStatusBar:SetMinMaxValues(0, ISync_OptCount);
			ISync_Optimize_Bar:Show();
		end
		
		
	
	end

	
	
	--if we are starting off then begin at zero
	if(sNum == 0) then
	
		
		upNum = 0;
		
		--upNum = current num
		--ISync_OptCount = up to num

		--start the processing loop
		for index, value in ISyncDB[ISync_RealmNum] do

			--it passed 500 so lets add it to a queue for later processing
			if(upNum > 500) then
				
				--update the progressbar
				ISync_Optimize_BarText:SetText( ISync_OptCount_Current.."/"..ISync_OptCount );
				ISync_Optimize_BarFrameStatusBar:SetValue(ISync_OptCount_Current);
			
				ISync:Optimize_Add(7, ISync.Optimize);

				return nil;

			--it hasn't passed 500 so lets add to the upnum and current reading
			else
				upNum = upNum + 1;

				ISync_OptCount_Current = ISync_OptCount_Current + 1;


				---------------------------------------------------------------------------
				if(index and ISync:GetData(index, "item") and ISync:GetData(index, "info")) then

					--check link
					local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X = GetItemInfo("item:"..ISync:GetData(index, "item"));

					if(name_X and link_X and ISync_RealmNum) then
					
						--get id
						sParseLink = nil; --reset
						sParseLink = string.gsub(ISync:GetData(index, "info"), "^(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+)$", "%1");

						--update quality if wrong
						local storeQuality = sParseLink;
						
						--only continue if there was something
						if(storeQuality and storeQuality ~= "") then
							storeQuality = tonumber(storeQuality);
							
							--if it doesn't match then store the correct one
							if(storeQuality ~= quality_X) then
								ISync:SetData(index, "quality", quality_X);
							end
							
						end
						
						--check the filter!
						--if it's a no no then delete it
						if(not ISync:CheckFilter(quality_X)) then
							ISyncDB[ISync_RealmNum][index] = nil;
							
							
						else
						

							--update the search information
							if(ISync.ParseTooltip and ISyncDB[ISync_RealmNum] and ISyncDB[ISync_RealmNum][index]) then
								UIParent.TooltipButton = 1;
								ISyncTooltip:SetOwner(UIParent, "ANCHOR_BOTTOMRIGHT");
								ISyncTooltip:SetHyperlink(link_X);
								ISync:ParseTooltip(index, ISync_RealmNum);
								ISyncTooltip:Hide();
							end


						end

					--IGNORE INVALIDS

					end
		
		
				end
				------------------------------------------------------------------------------
			
			end --if(upNum > 500) then

		end--end for


	else

		ISync_OptCount = 0;
		for index, value in ISyncDB[ISync_RealmNum] do
			ISync_OptCount = ISync_OptCount + 1;
		end
	
	
		--upNum = current num
		--ISync_OptCount = up to num
		
		
		upNum = 0;
		upNum2 = 0;

		--start the processing loop
		for index, value in ISyncDB[ISync_RealmNum] do
			
			--add to the new upcount to determine were we last wear
			upNum2 = upNum2 + 1;

			--make sure we start off where we were last time
			if(upNum2 >= sNum or upNum > 0 ) then

				--it passed 500 so lets add it to a queue for later processing
				--but make sure we haven't been asked to stop
				if(upNum > 500 and stopChk == 0) then

					--update the progressbar
					ISync_Optimize_BarText:SetText( ISync_OptCount_Current.."/"..ISync_OptCount );
					ISync_Optimize_BarFrameStatusBar:SetValue(ISync_OptCount_Current);
					
					ISync:Optimize_Add(7, ISync.Optimize);

					return nil;

				--it hasn't passed 500 so lets add to the upnum and current reading
				else
					upNum = upNum + 1;

					ISync_OptCount_Current = ISync_OptCount_Current + 1;

					---------------------------------------------------------------------------
					if(index and ISync:GetData(index, "item") and ISync:GetData(index, "info")) then

						--check link
						local name_X, link_X, quality_X, minLevel_X, class_X, subclass_X, maxStack_X = GetItemInfo("item:"..ISync:GetData(index, "item"));

						if(name_X and link_X and ISync_RealmNum) then

							--get id
							sParseLink = nil; --reset
							sParseLink = string.gsub(ISync:GetData(index, "info"), "^(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+)$", "%1");

							--update quality if wrong
							local storeQuality = sParseLink;

							--only continue if there was something
							if(storeQuality and storeQuality ~= "") then
								storeQuality = tonumber(storeQuality);

								--if it doesn't match then store the correct one
								if(storeQuality ~= quality_X) then
									ISync:SetData(index, "quality", quality_X);
								end

							end

							--check the filter!
							--if it's a no no then delete it
							if(not ISync:CheckFilter(quality_X)) then
								ISyncDB[ISync_RealmNum][index] = nil;


							else


								--update the search information
								if(ISync.ParseTooltip and ISyncDB[ISync_RealmNum] and ISyncDB[ISync_RealmNum][index]) then
									UIParent.TooltipButton = 1;
									ISyncTooltip:SetOwner(UIParent, "ANCHOR_BOTTOMRIGHT");
									ISyncTooltip:SetHyperlink(link_X);
									ISync:ParseTooltip(index, ISync_RealmNum);
									ISyncTooltip:Hide();
								end


							end

						--IGNORE INVALIDS

						end


					end
					------------------------------------------------------------------------------


				end --if(upNum > 500) then

			end--if(upNum2 >= sNum or upNum > 0 ) then

		end--end for
		
		
					------------------------------------------------------------------------------

					--if there was processing at the end then show
					--ISync_OptCount out of ISync_OptCount
					

					--check if there was some info left
					if(ISync_OptCount_Current >= ISync_OptCount) then

						--update the progressbar
						ISync_Optimize_BarText:SetText( ISync_OptCount_Current.."/"..ISync_OptCount );
						ISync_Optimize_BarFrameStatusBar:SetValue(ISync_OptCount_Current);
						ISync_Optimize_Bar:Hide(); --hide it

						DEFAULT_CHAT_FRAME:AddMessage("|c0000FF00ItemSync: "..ISYNC_OPTIMIZE_COMPLETE.."!");

						stopChk = 1;
						
						--Enable the button
						ISync_OptionsOptimizeButton:Enable();
			
						return nil;
					end
					

	end--end if
	
	--reset
	ISync_OptCount  = 0;
	ISync_Optimize_Bar:Hide(); --hide it just in case

	--clean the database
	ISync:CleanDatabase();
		
	--Enable the button
	ISync_OptionsOptimizeButton:Enable();
	

	--if the itemcount is less then 500 show end
	if(ISync_OptCount < 500) then
		DEFAULT_CHAT_FRAME:AddMessage("|c0000FF00ItemSync: "..ISYNC_OPTIMIZE_COMPLETE.."!");
	end
	

end