--constanst
mifontBlue = "|cff00ccff";
mifontGreen = "|cff00ff00";
mifontRed = "|cffff0000";
mifontGold = "|cffffcc00";
mifontGray = "|cff888888";
mifontWhite = "|cffffffff";
mifontSubWhite = "|cffbbbbbb";
mifontMageta = "|cffff00ff";
mifontYellow  = "|cffffff00";
mifontCyan   = "|cff00ffff";

miVersionNo = ' 2.52'

miVersion = mifontYellow..'MobInfo-2 Version '..miVersionNo..mifontGreen..' http://www.dizzarian.com/forums/viewforum.php?f=16';
miPatchNotes = mifontYellow..
  'MobInfo-2 Version '..miVersionNo..'\n'..
  '  ver 2.52\n'..
  '    - updated to officially support WoW 1.9\n'..
  '    - added a mob name search option to search page\n\n'..
  '  ver 2.51\n'..
  '    - fixed the compact tooltip problem of messing up tootips of other AddOns\n'..
  '    - updated several french translations\n\n'..
  '  ver 2.50\n'..
  '    - new feature : Mob database search page with lots of search options\n'..
  '    - new feature : compact tooltip mode\n\n'..
  '  For all previous patch notes and to report bugs please visit http://www.dizzarian.com/forums/viewforum.php?f=16';
  

-- Configs
function MI2_SlashAction_Default()
	MobInfoConfig.ShowClass = 1;
	MobInfoConfig.ShowHealth = 1;
    MobInfoConfig.ShowMana = 0;
	MobInfoConfig.ShowDamage = 1;
	MobInfoConfig.ShowKills = 0;
	MobInfoConfig.ShowLoots = 1;
	MobInfoConfig.ShowEmpty = 0;
	MobInfoConfig.ShowXp = 1;
	MobInfoConfig.ShowNo2lev = 1;
	MobInfoConfig.ShowQuality = 1;
	MobInfoConfig.ShowCloth = 1;
	MobInfoConfig.ShowCoin = 0;
	MobInfoConfig.ShowIV = 0;
	MobInfoConfig.ShowTotal = 1;
	MobInfoConfig.ShowCombined = 0;
end

function MI2_SlashAction_AllOn()
    MobInfoConfig.ShowClass = 1;
    MobInfoConfig.ShowHealth = 1;
    MobInfoConfig.ShowMana = 1;
    MobInfoConfig.ShowKills = 1;
    MobInfoConfig.ShowDamage = 1;
    MobInfoConfig.ShowXp = 1;
    MobInfoConfig.ShowNo2lev = 1;
    MobInfoConfig.ShowLoots = 1;
    MobInfoConfig.ShowEmpty = 1;
    MobInfoConfig.ShowCoin = 1;
    MobInfoConfig.ShowIV = 1;
    MobInfoConfig.ShowTotal = 1;
    MobInfoConfig.ShowQuality = 1;
    MobInfoConfig.ShowCloth = 1;
    MobInfoConfig.ShowCombined = 1;
end

function MI2_SlashAction_AllOff()
    MobInfoConfig.ShowClass = 0;
    MobInfoConfig.ShowHealth = 0;
    MobInfoConfig.ShowMana = 0;
    MobInfoConfig.ShowKills = 0;
    MobInfoConfig.ShowDamage = 0;
    MobInfoConfig.ShowXp = 0;
    MobInfoConfig.ShowNo2lev = 0;
    MobInfoConfig.ShowLoots = 0;
    MobInfoConfig.ShowEmpty = 0;
    MobInfoConfig.ShowCoin = 0;
    MobInfoConfig.ShowIV = 0;
    MobInfoConfig.ShowTotal = 0;
    MobInfoConfig.ShowQuality = 0;
    MobInfoConfig.ShowCloth = 0;
    MobInfoConfig.ShowCombined = 0;
end

function MI2_SlashAction_Minimal()
    MobInfoConfig.ShowClass = 1;
    MobInfoConfig.ShowHealth = 1;
    MobInfoConfig.ShowMana = 0;
    MobInfoConfig.ShowKills = 0;
    MobInfoConfig.ShowDamage = 0;
    MobInfoConfig.ShowXp = 0;
    MobInfoConfig.ShowNo2lev = 1;
    MobInfoConfig.ShowLoots = 0;
    MobInfoConfig.ShowEmpty = 0;
    MobInfoConfig.ShowCoin = 0;
    MobInfoConfig.ShowIV = 0;
    MobInfoConfig.ShowTotal = 1;
    MobInfoConfig.ShowQuality = 0;
    MobInfoConfig.ShowCloth = 0;
    MobInfoConfig.ShowCombined = 0;
end


-----------------------------------------------------------------------------
-- MI2_RegisterWithAddonManagers()
--
-- Register MobInfo with the KHAOS AddOn manager. This is a very simple
-- registration that merely creates a button to open the MobInfo options
-- dialog.
--
-- Register MobInfo with the myAddons manager.
--
-- Register with the EARTH AddOn manager.
-----------------------------------------------------------------------------
function MI2_RegisterWithAddonManagers()

	-- register with myAddons manager
	if ( myAddOnsFrame_Register ) then
		local mobInfo2Details = {
		name = "MobInfo2",
		version = miVersionNo,
		author = "Skeeve & Dizzarian",
		website = "http://www.dizzarian.com/forums/viewforum.php?f=16",
		category = MYADDONS_CATEGORY_OTHERS,
		optionsframe = "frmMIConfig"
		};
		myAddOnsFrame_Register( mobInfo2Details );
	end

	-- register with EARTH manager (mainly for Cosmos support)
	if EarthFeature_AddButton then
		EarthFeature_AddButton(
			{
				id = "MobInfo2";
				name = "MobInfo2";
				subtext = "v"..miVersionNo;
				tooltip = MI_DESCRIPTION;
				icon = "Interface\\AddOns\\MobInfo2\\MobInfoIcon";
				callback = function(state) MI2_SlashParse( "", false ); end;
				test = nil;
			}
		);
	
	-- register with KHAOS (only if EARTH not found)
	elseif Khaos then
		Khaos.registerOptionSet (
			"tooltip",
			{
				id = "MobInfo2OptionSet";
				text = "MobInfo 2";
				helptext = MI_DESCRIPTION;
				difficulty = 1;
				callback = function(state) end;
				default = true;
				options = {
					{
						id = "MobInfo2OptionsHeader";
						type = K_HEADER;
						difficulty = 1;
						text = MI_TXT_WELCOME;
						helptext = MI_DESCRIPTION;
					},
					{
						id = "MobInfo2OptionsButton";
						type = K_BUTTON;
						difficulty = 1;
						text = MI_TXT_CONFIG_TITLE;
						helptext = "";
						callback = function(state) MI2_SlashParse( "", false ); end;
						feedback = function(state) end;
						setup = { buttonText = MI_TXT_OPEN };
					}
				}
			}
		)

	end
	
end -- MI2_RegisterWithAddonManagers()


-----------------------------------------------------------------------------
-- MI2_SlashAction_ClearTarget()
--
-- Clear MobInfo and MobHealth data for current target.
-----------------------------------------------------------------------------
function MI2_SlashAction_ClearTarget()
	if  MI2_Target  then
		local index = MI2_Target.mobIndex;
		if  MobInfoDB[index]  or  MobHealthDB[index]  then
			MI2_MobHealth_ClearTargetData();
			MobInfoDB[index] = nil;
			MobHealthDB[index] = nil;
			MI2_DbOptionsFrameOnShow();
			chattext( "data for "..mifontGreen..index..mifontWhite.." has been cleared" );
		end
	end
end  -- MI2_SlashAction_ClearTarget()


-----------------------------------------------------------------------------
-- MI2_Slash_ClearAllConfirmed()
--
-- Clear-All-Confirmation-Handler : Clear entire contents of MobInfo and
-- MobHealth databases.
-----------------------------------------------------------------------------
function MI2_Slash_ClearAllConfirmed()
	chattext( "MI_DBG: MI2_Slash_ClearAllConfirmed !!!" );
	MobInfoDB = {};
	MI2_MobHealth_Reset();
	MI2_DbOptionsFrameOnShow();
	chattext( "data for ENTIRE MobInfo and MobHealth databases has been cleared" );
end


-----------------------------------------------------------------------------
-- MI2_SlashAction_ClearAll()
--
-- Clear entire contents of MobInfo and MobHealth databases.
-- Ask for confirmation before performing the clear operation.
-----------------------------------------------------------------------------
function MI2_SlashAction_ClearAll()
	StaticPopupDialogs["MOBINFO_CONFIRMATION"].text = MI_TXT_CLR_ALL_CONFIRM;
	StaticPopupDialogs["MOBINFO_CONFIRMATION"].OnAccept = MI2_Slash_ClearAllConfirmed;
	local dialog = StaticPopup_Show( "MOBINFO_CONFIRMATION", "yeeehaaaa");
end  -- MI2_SlashAction_ClearAll()


-----------------------------------------------------------------------------
-- MI2_SlashInit()
--
-- Add all Slash Commands
-----------------------------------------------------------------------------
function MI2_SlashInit()
  SlashCmdList["MOBINFO"] = MI2_SlashParse;
  SLASH_MOBINFO1 = "/mobinfo2"; 
  SLASH_MOBINFO2 = "/mi2"; 
end


-----------------------------------------------------------------------------
-- MI2_SlashParse()
--
-- Parses the msg entered as a slash command. This function is also used
-- for the internal purpose of setting all options in the options dialog.
-- When used by the options dialog there is no need to actually update the
-- dialog, which is indicated by the "updateOptions" parameter.
-----------------------------------------------------------------------------
function MI2_SlashParse( msg, updateOptions )

  -- extract option name and option argument from message string
  local _, _, cmd, param = string.find( string.lower(msg), "(%w+)[ ]*([-%w]*)"); 
  
  -- handle show/hide of options dialog first of all
  -- handle all simple commands that dont require parsing right here
  if  not cmd  or  cmd == ""  or  cmd == "config"  then
    if  frmMIConfig:IsVisible()  then
		frmMIConfig:Hide();
	else
		frmMIConfig:Show();
	end
	return;
  elseif  cmd == 'version'  then
    chattext( miVersion );
	return;
  elseif  cmd == 'notes'  then
    chattext( miPatchNotes );
	return;
  elseif  cmd == 'help'  then
    chattext( mifontYellow.. 'Usage /mobinfo2 <cmd> or /mi2 <cmd>' );
    chattext( 'Where <cmd> is any of the following' );
    for index, value in MI2_OPTIONS do
      if  value.cmnd ~= ""  then
        chattext( mifontGreen..value.cmnd..' - '..mifontYellow..value.help );
      end
    end
	return;
  end

  -- search for the option data structure matching the command
  local optionName, optionData;
  for index, value in MI2_OPTIONS do
    if  value.cmnd == cmd  then
      optionName = string.sub(index, 8);
      optionData = value;
      break;
    end
  end

--chattext( "MI_DBG: cmd=["..cmd.."], param="..param..", option="..(optionName or "<nil>")..", v="..(optionData.v or "<nil>") );

  -- now call the option handler for the more complex commands
  if  optionData  then
    MI2_OptionParse( optionName, optionData, param, updateOptions );
  end

end -- MI2_SlashParse()


-----------------------------------------------------------------------------
-- MI2_OptionParse()
--
-- Parses the more complex option toggle/set commands. There are 3
-- categories of options:
--   * options that can toggle between an on and off state
--   * options that represent a numeric value
--   * options that activate a special functionality represented by a
--     handler function that must correspond to a specific naming convention
-----------------------------------------------------------------------------
function MI2_OptionParse( optionName, optionData, param, updateOptions )
	-- handle the option according to its option type: its either a
	-- switch being toggleg, a value being set, or a special action
	if  optionData.v == 1  then
		-- it is a value set option:
		-- get new option value from parameter and set it
		local optValue = tonumber( param ) or 0;
		MobInfoConfig[optionName] = optValue;
		if  updateOptions  then
			chattext( optionData.text.." : "..mifontGreen..optValue );
		end

	elseif  MobInfoConfig[optionName]  then
		-- it is a switch toggle option:
		-- get current option value and toggle it to the opposite state (On<->Off)
		local valTxt = { val0 = "-OFF-" ; val1 = "-ON-" };
		local optValue = MobInfoConfig[ optionName ];
		optValue = 1 - optValue;  -- toggle option
		MobInfoConfig[optionName] = optValue;
		chattext( optionData.text.." : "..mifontGreen..valTxt["val"..optValue] );

		-- special case: disabling MobInfo requires extra processing
		if optionName == "DisableMobInfo" then MI2_UpdateMobInfoState(); end

	else
		-- special action commands have a corresponding handler function
		local actionHandlerName = "MI2_SlashAction_"..optionName;
		local actionHandler = getglobal( actionHandlerName );
		if  actionHandler  then
			actionHandler();
			updateOptions = true; -- for AllOn, AllOff, etc.
		end
	end

	-- update font and position of health / mana texts
	MI2_MobHealth_SetPos();

	-- update options dialog if shown and if requested
	if  frmMIConfig:IsVisible()  and  updateOptions  then
		MI2_UpdateOptions();
	end

end  -- MI2_OptionParse()

